import { Get, Promisable } from 'type-fest';
import { Changeset, ValidationError, ValidationFunction } from "../changeset-0b495e1f.js";
import { OnSetCallback } from "../immer-changeset-36d7e0a3.js";
declare class ImmerChangeset<T extends Record<string, any> = Record<string, any>> implements Changeset<T> {
    data: T;
    private draftData;
    private innerErrors;
    private patches;
    private inversePatches;
    private eventEmitter;
    get changes(): import("../changeset-0b495e1f.js").Change[];
    get errors(): ValidationError[];
    get isValid(): boolean;
    get isPristine(): boolean;
    get isInvalid(): boolean;
    get isDirty(): boolean;
    constructor(data: T);
    execute(): void;
    unexecute(): void;
    save(): Promisable<void>;
    rollback(): void;
    rollbackProperty(property: string): void;
    addError(key: string, error: ValidationError): void;
    removeError(key: string): void;
    get<K extends string>(key: K): Get<T, K>;
    set<K extends string>(key: K, value: Get<T, K>): void;
    validate(validation: ValidationFunction<T>): Promise<void>;
    private normalizedPatches;
    private resetPatches;
    onSet(fn: OnSetCallback<ImmerChangeset, T>): () => void;
}
export { ImmerChangeset };
//# sourceMappingURL=changeset/immer-changeset.d.ts.map