/// <reference types="ember__owner" />
import Owner from '@ember/owner';
import Component from '@glimmer/component';
import { Promisable } from 'type-fest';
import { ImmerChangeset } from "../changeset/immer-changeset.js";
interface ChangesetFormComponentArgs<T extends ImmerChangeset> {
    changeset: T;
    onSubmit: (changeset: T) => Promisable<unknown>;
    validationFunction: Parameters<ImmerChangeset['validate']>[0];
}
declare class ChangesetFormComponent extends Component<ChangesetFormComponentArgs<ImmerChangeset>> {
    constructor(owner: Owner, args: ChangesetFormComponentArgs<ImmerChangeset>);
    validateAndSubmit(): Generator<unknown, void, unknown>;
    submit(e: Event): Generator<import("ember-concurrency").TaskInstance<void>, void, unknown>;
}
export { ChangesetFormComponentArgs, ChangesetFormComponent as default };
