import { _ as _applyDecoratedDescriptor, I as ImmerChangeset } from '../immer-changeset-36d7e0a3.js';
import Component from '@glimmer/component';
import { assert } from '@ember/debug';
import { dropTask, task } from 'ember-concurrency';
import { waitFor } from '@ember/test-waiters';
import { taskFor } from 'ember-concurrency-ts';
import { isChangeset } from '../utils/is-changeset.js';
import { precompileTemplate } from '@ember/template-compilation';
import { setComponentTemplate } from '@ember/component';

var TEMPLATE = precompileTemplate("<form {{on \"submit\" (perform this.submit)}} ...attributes>\n    {{yield this.validateAndSubmit}}\n</form>");

var _class;
let ChangesetFormComponent = (_class = class ChangesetFormComponent extends Component {
  constructor(owner, args) {
    super(owner, args);
    assert('@changeset is required and must be an ImmerChangeset', isChangeset(args.changeset) && args.changeset instanceof ImmerChangeset);
    assert('@onSubmit is required', typeof args.onSubmit === 'function');
    assert('@validationFunction is required', typeof args.validationFunction === 'function');
  }
  *validateAndSubmit() {
    yield this.args.changeset.validate(this.args.validationFunction);
    if (this.args.changeset.isValid) {
      yield this.args.onSubmit(this.args.changeset);
    }
  }
  *submit(e) {
    e.preventDefault();
    const task = taskFor(this.validateAndSubmit);
    yield task.perform();
  }
}, (_applyDecoratedDescriptor(_class.prototype, "validateAndSubmit", [dropTask], Object.getOwnPropertyDescriptor(_class.prototype, "validateAndSubmit"), _class.prototype), _applyDecoratedDescriptor(_class.prototype, "submit", [task, waitFor], Object.getOwnPropertyDescriptor(_class.prototype, "submit"), _class.prototype)), _class);
setComponentTemplate(TEMPLATE, ChangesetFormComponent);

export { ChangesetFormComponent as default };
//# sourceMappingURL=immer-form.js.map
