import { Change } from "./changeset-0b495e1f.js";
import { StringKeyOf } from 'type-fest';
import { ImmerChangeset } from "./index.js";
declare function aggregatedLastChanges(arr: Change[]): Change[];
type OnSetCallback<T extends ImmerChangeset, DTO extends Record<string, any>> = (key: StringKeyOf<DTO>, value: unknown, changeset: T) => void;
interface EventMap<T extends ImmerChangeset, DTO extends Record<string, any>> {
    set: Map<Symbol, OnSetCallback<T, DTO>>;
}
type MapValue<T extends ImmerChangeset, DTO extends Record<string, any>, K extends StringKeyOf<EventMap<T, DTO>>> = EventMap<T, DTO>[K] extends Map<Symbol, infer Callback> ? Callback : never;
declare class ChangesetEventEmitter<T extends ImmerChangeset, DTO extends Record<string, any>> {
    private changeset;
    private events;
    constructor(changeset: T);
    emitOnSet<K extends StringKeyOf<DTO>>(key: K, value: DTO[K]): void;
    on<K extends StringKeyOf<EventMap<T, DTO>>>(event: K, callback: MapValue<T, DTO, K>): Symbol;
    off<K extends StringKeyOf<EventMap<T, DTO>>>(event: K, uniqueId: Symbol): void;
}
export { aggregatedLastChanges, OnSetCallback, ChangesetEventEmitter };
